VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFtpCom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''
' Implementa le funzioni di FTP.
'
' @remarks La abbiamo dovuta scrivere perch l'oggetto MSINET.OCX funziona male.
' @author Marcello e Luca
Option Explicit

''
' Nome del file da mandare o da ricevere.
'
' @remarks Questo  il file locale, pu avere anche la path completa o relativa.
Public sNomeFile As String
' esempio:          C:\progetti\eastipcom\francesca.txt

''
' Nome del file remoto da mandare o da ricevere.
'
' @remarks Questo  il file remoto, e solitamente non ha path.
Public sNomeFileRemoto As String
' esempio:    francesca.txt

''
' Nome del file da cancellare prima di inviare (opzionale)
'
' @remarks Visto che si manda un file di richiesta per ottenere un file di risposta,  saggio cancellare il vecchio file di risposta.
' @remarks Lo puoi mettere qui, e verr cancellato dal server remoto.
Public sNomeFileVecchio

''
' Indirizzo o nome dell'host remoto.
'
' @remarks Ci si mette l'indirizzo del server FTP.
Public sIndirizzo As String

''
' Utente per il collegamento FTP.
'
' @remarks L'utente  obbligatorio.
Public sUsername As String

''
' Password per l'accesso.
'
' @remarks La sai la password? No? Allora niente accesso.
Public sPwd As String

Private m_nNumeroErrore As Long
Private m_sDescrizioneErrore As String
Private m_Proxy As String
Private m_internetOpenTpye As Long
Private m_TransferType As String

Private nInet As Long, nInetConn As Long


' dichiarative WININET.DLL
'InternetOpen - lAccessType
Private Const INTERNET_OPEN_TYPE_PRECONFIG As Long = 0
Private Const INTERNET_OPEN_TYPE_DIRECT    As Long = 1
Private Const INTERNET_OPEN_TYPE_PROXY     As Long = 3
Private Const INTERNET_FLAG_RELOAD         As Long = -2147483648# ' 0x80000000
Private Const FTP_TRANSFER_TYPE_UNKNOWN    As Long = 0
Private Const FTP_TRANSFER_TYPE_ASCII      As Long = 1
Private Const FTP_TRANSFER_TYPE_BINARY     As Long = 2

'InternetOpen
Private Declare Function InternetOpen _
    Lib "wininet.dll" _
    Alias "InternetOpenA" ( _
        ByVal sAgent As String, _
        ByVal lAccessType As Long, _
        ByVal sProxyName As String, _
        ByVal sProxyBypass As String, _
        ByVal lFlags As Long _
    ) As Long

Private Declare Function InternetConnect _
    Lib "wininet.dll" _
    Alias "InternetConnectA" ( _
        ByVal hInternetSession As Long, _
        ByVal sServerName As String, _
        ByVal nServerPort As Integer, _
        ByVal sUsername As String, _
        ByVal sPassword As String, _
        ByVal lService As Long, _
        ByVal lFlags As Long, _
        ByVal lContext As Long _
        ) As Long

'FtpGetFile
Private Declare Function FtpGetFile _
    Lib "wininet.dll" _
    Alias "FtpGetFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszRemoteFile As String, _
    ByVal lpszNewFile As String, _
    ByVal fFailIfExists As Boolean, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long _
    ) As Boolean

'FtpPutFile
Private Declare Function FtpPutFile _
    Lib "wininet.dll" _
    Alias "FtpPutFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszLocalFile As String, _
    ByVal lpszRemoteFile As String, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long _
    ) As Boolean

'FtpDeleteFile
Private Declare Function FtpDeleteFile _
    Lib "wininet.dll" _
    Alias "FtpDeleteFileA" ( _
    ByVal hFtpSession As Long, _
    ByVal lpszFileName As String _
    ) As Boolean

'InternetCloseHandle
Private Declare Function InternetCloseHandle _
    Lib "wininet.dll" _
    (ByVal hInet As Long) As Integer

Private Type FILETIME
                                dwLowDateTime As Long
                                dwHighDateTime As Long
                        End Type


Private Type WIN32_FIND_DATA
                                dwFileAttributes As Long
                                ftCreationTime As FILETIME
                                ftLastAccessTime As FILETIME
                                ftLastWriteTime As FILETIME
                                nFileSizeHigh As Long
                                nFileSizeLow As Long
                                dwReserved0 As Long
                                dwReserved1 As Long
                                cFileName As String * 25
                                cAlternate As String * 14
                        End Type

Private Declare Function FtpFindFirstFile Lib "wininet.dll" Alias "FtpFindFirstFileA" _
                            (ByVal hFtpSession As Long, ByVal lpszSearchFile As String, _
                            lpFindFileData As WIN32_FIND_DATA, ByVal dwFlags As Long, _
                            ByVal dwContent As Long) As Long


Private Function Inizializza() As Boolean
    Dim BOk As Boolean
    
    BOk = True
    
    nInet = InternetOpen("EastIP", m_internetOpenTpye, m_Proxy, "", 0)
    If nInet = 0 Then
        BOk = False
        m_nNumeroErrore = Err.LastDllError
        m_sDescrizioneErrore = "Impossibile aprire connessione ad Host Remoto"
    End If
    
    If BOk Then
        nInetConn = InternetConnect(nInet, sIndirizzo, 0, sUsername, sPwd, 1, 0, 0)
        If nInetConn = 0 Then
            BOk = False
            m_nNumeroErrore = Err.LastDllError
            m_sDescrizioneErrore = "Impossibile connettersi ad Host Remoto"
        End If
    End If
    
    If BOk Then
        If sNomeFileRemoto = "" Then sNomeFileRemoto = sNomeFile
    End If
    
    Inizializza = BOk

End Function

Private Sub Chiusura()
    If nInetConn <> 0 Then _
        InternetCloseHandle nInetConn
        
    If nInet <> 0 Then _
        InternetCloseHandle nInet
End Sub

''
' Invia il file via FTP.
'
' @return Vero se il trasferimento ha avuto successo, falso altrimenti.
' @remarks Prima di inviare cancella il file specificato in sNomeFileVecchio. Se torna falso si pu controllare il numero e il messaggio di errore.
' @see sNomeFileVecchio
Public Function Manda() As Boolean
' ritorna vero o falso;
' se falso si deve controllare nNumeroErrore
            
    Dim BOk As Boolean
    Dim BOkDelete As Boolean
    
    BOk = Inizializza()
    
    ' fase di cancellazione del vecchio file
    If BOk And (sNomeFileVecchio <> "") Then
        BOkDelete = FtpDeleteFile(nInetConn, sNomeFileVecchio)
        ' non si deve controllare l'esito della cancellazione,
        ' perch il file vecchio potrebbe non esserci.
        ' la var BOkDelete serve solo per la memorizzazione del risultato
        ' della FtpDeleteFile
    End If
    
    ' fase di invio
    If BOk Then
        BOk = FtpPutFile(nInetConn, sNomeFile, sNomeFileRemoto, m_TransferType, 0)
        If BOk = False Then
            m_nNumeroErrore = Err.LastDllError
            m_sDescrizioneErrore = "Errore nell'invio. Ritentare."
        End If
    End If
    
    Chiusura
    
    Manda = BOk
    
End Function

''
' Recupera il file via FTP.
'
' @return Vero se il trasferimento ha avuto successo, falso altrimenti.
' @remarks Se torna falso si pu controllare il numero e il messaggio di errore.
' @see nNumeroErrore
Public Function Ricevi() As Boolean
' ritorna vero o falso;
' se falso si deve controllare nNumeroErrore

    Dim BOk As Boolean
            
    BOk = Inizializza()

    
    ' ricezione
    If BOk Then
        BOk = FtpGetFile(nInetConn, sNomeFileRemoto, sNomeFile, False, m_TransferType, INTERNET_FLAG_RELOAD Or FTP_TRANSFER_TYPE_ASCII, 0)
        If BOk = False Then
            m_nNumeroErrore = Err.LastDllError
            If nNumeroErrore = 12003 Then
                m_sDescrizioneErrore = "Risposta non presente. Ritentare pi tardi."
            Else
                m_sDescrizioneErrore = "Errore nella ricezione. Ritentare."
            End If
        End If
    End If
    
    Chiusura
    
    Ricevi = BOk
    
End Function

''
' Codice dell'ultimo errore occorso.
'
' @return Codice dell'ultimo errore occorso.
' @remarks Codice dell'ultimo errore occorso.
Public Property Get nNumeroErrore() As Integer
    nNumeroErrore = m_nNumeroErrore
End Property

''
' Descrizione dell'ultimo errore occorso.
'
' @return Descrizione dell'ultimo errore occorso.
' @remarks Descrizione dell'ultimo errore occorso.
Public Property Get sDescrizioneErrore() As String
    sDescrizioneErrore = m_sDescrizioneErrore
End Property


''
' Proxy server usato per la connessione.
'
' @return Indirizzo o nome del proxy server usato per la connessione.
Public Property Get Proxy() As String
    Proxy = m_Proxy
End Property

''
' Proxy server usato per la connessione.
'
' @param s      nome o indirizzo del proxy
' @remarks Impostare questo parametro se hai bisogno di usare un proxy.
Public Property Let Proxy(s As String)
    If s = "" Then
        m_Proxy = ""
        m_internetOpenTpye = INTERNET_OPEN_TYPE_DIRECT
    Else
        m_Proxy = s
        m_internetOpenTpye = INTERNET_OPEN_TYPE_PROXY
    End If
End Property

''
' Tipo di file da trasferire.
'
' @return Una stringa con il tipo di trasferimento
' @remarks Ritorna "A" se il file  ASCII, "B" se  binario.
Public Property Get TransferType() As String
     If m_TransferType = FTP_TRANSFER_TYPE_ASCII Then
        TransferType = "A"
    Else
        TransferType = "B"
    End If
End Property

''
' Tipo di file da trasferire.
'
' @param s      tipo di file da trasferire
' @remarks Si pu impostare a "A" se il file da trasferire  ASCII, "B" o "I" se  binario o niente se non si sa.
Public Property Let TransferType(s As String)
    Select Case Trim(UCase(s))
        Case "A"
            m_TransferType = FTP_TRANSFER_TYPE_ASCII
        Case "B", "I"
            m_TransferType = FTP_TRANSFER_TYPE_BINARY
        Case ""
            m_TransferType = FTP_TRANSFER_TYPE_UNKNOWN
        Case Else
            Err.Raise vbObjectError + 560, , "TranferType accetta solo A, B e I."
        End Select
        
End Property

Private Sub Class_Initialize()
    m_internetOpenTpye = INTERNET_OPEN_TYPE_DIRECT
    m_TransferType = FTP_TRANSFER_TYPE_UNKNOWN
End Sub
